﻿Imports System.IO

Module DataFiles
    Public Sub LoadCharacterData()
        Dim ver As String = My.Application.Info.Version.ToString
        Variables.LoadDisable = True
        Try
            Form1.LoadChar.InitialDirectory = My.Application.Info.DirectoryPath & "\Data\Characters\"
            Dim result As DialogResult = Form1.LoadChar.ShowDialog()

            If result = DialogResult.OK Then
                Variables.CurrentGear.Clear()
                Variables.CurrentGems.Clear()
                Variables.CurrentEnchants.Clear()
                Variables.GearSetHash.Clear()
                Dim rawfile() As String = File.ReadAllLines(Form1.LoadChar.FileName)
                Dim fileVersion As String = rawfile(0) ' Save file version
                If ver <> fileVersion Then
                    MessageBox.Show("Save file is outdated.  Loading what I can.  Check your options and save the data." & vbCrLf _
                                    & "Check the Results tab for errors." & vbCrLf _
                                    & "Consider importing your character fresh.")
                End If

                Dim r0() As String = Split(rawfile(1), ",") ' Basic Character Info
                Dim r1() As String = Split(rawfile(2), ",") ' Talents, glpyhs
                Dim r2() As String = Split(rawfile(3), ",") ' Buffs
                Dim r3() As String = Split(rawfile(4), ",") ' Combat Options

                ' Line 1 is the file version.
                ' Line 2: Basic Info
                Try
                    Form1.CharSelect.Text = r0(0)
                    Form1.RealmSelect.Text = Replace(r0(1), "_", " ")
                    Form1.RaceSelect.Text = r0(2)
                    Form1.ZoneSelect.Text = r0(3)
                Catch
                    Form1.TextBox1.AppendText("Failed to load basic info." & vbCrLf)
                End Try

                ' Line 3: Talents, glyphs
                Try
                    Form1.Talent_Acuity.Text = r1(0)
                    Form1.Talent_Concussion.Text = r1(1)
                    Form1.Talent_CallofFlame.Text = r1(2)
                    Form1.Talent_ElementalPrecision.Text = r1(3)
                    Form1.Talent_RollingThunder.Text = r1(4)
                    Form1.Talent_LavaFlows.Text = r1(5)
                    Form1.Talent_Fulmination.Text = r1(6)
                    Form1.Talent_LavaSurge.Text = r1(7)
                    Form1.Talent_ElementalWeapons.Text = r1(8)

                    If r1(9) = "1" Then Form1.GoFTWCheckBox.Checked = True Else Form1.GoFTWCheckBox.Checked = False
                    If r1(10) = "1" Then Form1.GoLCheckBox.Checked = True Else Form1.GoLCheckBox.Checked = False
                    If r1(11) = "1" Then Form1.GoLBCheckBox.Checked = True Else Form1.GoLBCheckBox.Checked = False
                    If r1(12) = "1" Then Form1.GoFSCheckBox.Checked = True Else Form1.GoFSCheckBox.Checked = False
                    If r1(13) = "1" Then Form1.GoSCheckBox.Checked = True Else Form1.GoSCheckBox.Checked = False
                Catch
                    Form1.TextBox1.AppendText("Failed to load talent info." & vbCrLf)
                End Try

                ' Line 4: Buffs
                Try
                    If r2(0) = "1" Then Form1.FlameTongueWeapon.Checked = True Else Form1.FlameTongueWeapon.Checked = False
                    If r2(1) = "1" Then Form1.MailSpecialization.Checked = True Else Form1.MailSpecialization.Checked = False
                    If r2(2) = "1" Then Form1.Heroism.Checked = True Else Form1.Heroism.Checked = False
                    If r2(3) = "1" Then Form1.TotemicWrath.Checked = True Else Form1.TotemicWrath.Checked = False
                    If r2(4) = "1" Then Form1.WrathofAir.Checked = True Else Form1.WrathofAir.Checked = False
                    If r2(5) = "1" Then Form1.CurseofElements.Checked = True Else Form1.CurseofElements.Checked = False
                    If r2(6) = "1" Then Form1.WintersChill.Checked = True Else Form1.WintersChill.Checked = False
                Catch ex As Exception
                    Form1.TextBox1.AppendText("Failed to load buff info." & vbCrLf)
                End Try

                ' Line 5: Combat Options
                Try
                    If r3(0) = "1" Then Form1.Spells_LB.Checked = True Else Form1.Spells_LB.Checked = False
                    If r3(1) = "1" Then Form1.Spells_CL.Checked = True Else Form1.Spells_CL.Checked = False
                    If r3(2) = "1" Then Form1.Spells_FS.Checked = True Else Form1.Spells_FS.Checked = False
                    If r3(3) = "1" Then Form1.Spells_LvB.Checked = True Else Form1.Spells_LvB.Checked = False
                    If r3(4) = "1" Then Form1.Spells_UE.Checked = True Else Form1.Spells_UE.Checked = False
                    If r3(5) = "1" Then Form1.Spells_ES.Checked = True Else Form1.Spells_ES.Checked = False
                    If r3(6) = "1" Then Form1.doModel.Checked = True Else Form1.doModel.Checked = False
                    Form1.FightLength.Text = r3(7)
                    Form1.MobLevel.Text = r3(8)
                    Form1.AddSpellDmg.Text = r3(9)
                    Form1.AddCritPerc.Text = r3(10)
                    Form1.AddCritRate.Text = r3(11)
                    Form1.AddHitRate.Text = r3(12)
                    Form1.AddHasteRate.Text = r3(13)
                    Form1.AddMastRate.Text = r3(14)
                    Form1.ClearcastUptime.Text = r3(15)
                    Form1.LavaSurgeBenefit.Text = r3(16)
                    Form1.FulmCharge.Text = r3(17)
                    Form1.RollingThunderRamp.Text = r3(18)
                    Form1.DefBlueGem.Text = r3(19)
                    Form1.DefYellowGem.Text = r3(20)
                    Form1.DefRedGem.Text = r3(21)
                    Form1.DefMetaGem.Text = r3(22)
                    Form1.DefPrisGem.Text = r3(23)
                    Form1.Latency.Text = r3(24)
                    Form1.instaLatency.Text = r3(25)
                Catch
                    Form1.TextBox1.AppendText("Failed to load combat info." & vbCrLf)
                End Try

                ' Line 6+: Gear (Only first set (Read: line) is processed, all other sets are put inside GearSetHash hashtable.)
                Try
                    If UBound(rawfile) >= 5 Then
                        Dim r4() As String = Split(rawfile(5).Replace(" ", ""), ".") ' Gear Set 1
                        Dim r30() As String = Split(r4(0), ",") ' Items
                        Dim r31() As String = Split(r4(1), ",") ' Gems
                        Dim r32() As String = Split(r4(2), ",") ' Enchants
                        Variables.GearSetHash.Item(r30(0)) = rawfile(5)
                        Form1.SetCombo.Text = r30(0)
                        Form1.SetCombo.Items.Add(r30(0))
                        Form1.HeadCombo.Text = getItemNameFromId(r30(1))
                        getItemfromTextbox("Head", Form1.HeadCombo.Text)
                        Form1.NeckCombo.Text = getItemNameFromId(r30(2))
                        getItemfromTextbox("Neck", Form1.NeckCombo.Text)
                        Form1.ShouldersCombo.Text = getItemNameFromId(r30(3))
                        getItemfromTextbox("Shoulder", Form1.ShouldersCombo.Text)
                        Form1.BackCombo.Text = getItemNameFromId(r30(4))
                        getItemfromTextbox("Back", Form1.BackCombo.Text)
                        Form1.ChestCombo.Text = getItemNameFromId(r30(5))
                        getItemfromTextbox("Chest", Form1.ChestCombo.Text)
                        Form1.WristCombo.Text = getItemNameFromId(r30(6))
                        getItemfromTextbox("Wrist", Form1.WristCombo.Text)
                        Form1.MainHandCombo.Text = getItemNameFromId(r30(7))
                        getItemfromTextbox("MainHand", Form1.MainHandCombo.Text)
                        Form1.OffHandCombo.Text = getItemNameFromId(r30(8))
                        getItemfromTextbox("OffHand", Form1.OffHandCombo.Text)
                        Form1.RelicCombo.Text = getItemNameFromId(r30(9))
                        getItemfromTextbox("Relic", Form1.RelicCombo.Text)
                        Form1.HandsCombo.Text = getItemNameFromId(r30(10))
                        getItemfromTextbox("Hands", Form1.HandsCombo.Text)
                        Form1.WaistCombo.Text = getItemNameFromId(r30(11))
                        getItemfromTextbox("Waist", Form1.WaistCombo.Text)
                        Form1.LegsCombo.Text = getItemNameFromId(r30(12))
                        getItemfromTextbox("Legs", Form1.LegsCombo.Text)
                        Form1.FeetCombo.Text = getItemNameFromId(r30(13))
                        getItemfromTextbox("Feet", Form1.FeetCombo.Text)
                        Form1.Finger1Combo.Text = getItemNameFromId(r30(14))
                        getItemfromTextbox("Finger1", Form1.Finger1Combo.Text)
                        Form1.Finger2Combo.Text = getItemNameFromId(r30(15))
                        getItemfromTextbox("Finger2", Form1.Finger2Combo.Text)
                        Form1.Trinket1Combo.Text = getItemNameFromId(r30(16))
                        getItemfromTextbox("Trinket1", Form1.Trinket1Combo.Text)
                        Form1.Trinket2Combo.Text = getItemNameFromId(r30(17))
                        getItemfromTextbox("Trinket2", Form1.Trinket2Combo.Text)
                        ' Gems
                        Variables.CurrentGems.Add("Head", r31(0))
                        Variables.CurrentGems.Add("Neck", r31(1))
                        Variables.CurrentGems.Add("Shoulder", r31(2))
                        Variables.CurrentGems.Add("Back", r31(3))
                        Variables.CurrentGems.Add("Chest", r31(4))
                        Variables.CurrentGems.Add("Wrist", r31(5))
                        Variables.CurrentGems.Add("MainHand", r31(6))
                        Variables.CurrentGems.Add("OffHand", r31(7))
                        Variables.CurrentGems.Add("Relic", r31(8))
                        Variables.CurrentGems.Add("Hands", r31(9))
                        Variables.CurrentGems.Add("Waist", r31(10))
                        Variables.CurrentGems.Add("Legs", r31(11))
                        Variables.CurrentGems.Add("Feet", r31(12))
                        Variables.CurrentGems.Add("Finger1", r31(13))
                        Variables.CurrentGems.Add("Finger2", r31(14))
                        Variables.CurrentGems.Add("Trinket1", r31(15))
                        Variables.CurrentGems.Add("Trinket2", r31(16))
                        ' Enchants
                        Variables.CurrentEnchants.Add("Head", getEnchantInfo(r32(0), 1))
                        Variables.CurrentEnchants.Add("Neck", getEnchantInfo(r32(1), 1))
                        Variables.CurrentEnchants.Add("Shoulder", getEnchantInfo(r32(2), 1))
                        Variables.CurrentEnchants.Add("Back", getEnchantInfo(r32(3), 1))
                        Variables.CurrentEnchants.Add("Chest", getEnchantInfo(r32(4), 1))
                        Variables.CurrentEnchants.Add("Wrist", getEnchantInfo(r32(5), 1))
                        Variables.CurrentEnchants.Add("MainHand", getEnchantInfo(r32(6), 1))
                        Variables.CurrentEnchants.Add("OffHand", getEnchantInfo(r32(7), 1))
                        Variables.CurrentEnchants.Add("Relic", getEnchantInfo(r32(8), 1))
                        Variables.CurrentEnchants.Add("Hands", getEnchantInfo(r32(9), 1))
                        Variables.CurrentEnchants.Add("Waist", getEnchantInfo(r32(10), 1))
                        Variables.CurrentEnchants.Add("Legs", getEnchantInfo(r32(11), 1))
                        Variables.CurrentEnchants.Add("Feet", getEnchantInfo(r32(12), 1))
                        Variables.CurrentEnchants.Add("Finger1", getEnchantInfo(r32(13), 1))
                        Variables.CurrentEnchants.Add("Finger2", getEnchantInfo(r32(14), 1))
                        Variables.CurrentEnchants.Add("Trinket1", getEnchantInfo(r32(15), 1))
                        Variables.CurrentEnchants.Add("Trinket2", getEnchantInfo(r32(16), 1))
                    End If

                    If UBound(rawfile) > 5 Then
                        ' Load the other sets into the GearSetHash.
                        Dim i As Integer = 0
                        For i = 6 To rawfile.Count - 1
                            Dim tempi() As String = Split(rawfile(i), ",")
                            If rawfile(i) <> "" Then
                                rawfile(i).Replace(" ", "")
                                Variables.GearSetHash.Item(tempi(0)) = rawfile(i)
                                Form1.SetCombo.Items.Add(tempi(0))
                            End If
                        Next
                    End If
                Catch
                    Form1.TextBox1.AppendText("Failed to load gear info." & vbCrLf)
                End Try
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading character data." & vbCrLf & "Details in result tab.")
            Form1.TextBox1.AppendText(ex.Message & vbCrLf)
        End Try
        Variables.LoadDisable = False
    End Sub

    Public Sub SaveCharacterData()
        ' Write all char level, race, gear, gems, and talents to a data file.
        Dim name As String = Form1.CharSelect.Text
        Dim realm As String = Form1.RealmSelect.Text
        realm = Replace(realm, " ", "_")
        Dim charfile As String = "Data\Characters\" & name & "-" & realm & ".char"
        Dim output As String = ""
        ' Delete existing char file.
        If File.Exists(charfile) Then File.Delete(charfile)
        ' Line 1: Version information
        output = My.Application.Info.Version.ToString

        output &= vbCrLf
        ' Line 2: Compose Character Info
        output &= name & ","
        output &= realm & ","
        output &= Form1.RaceSelect.Text & ","
        output &= Form1.ZoneSelect.Text

        output &= vbCrLf
        ' Line 3: Compose Character Talent and Glyph info
        output &= Form1.Talent_Acuity.Text & ","
        output &= Form1.Talent_Concussion.Text & ","
        output &= Form1.Talent_CallofFlame.Text & ","
        output &= Form1.Talent_ElementalPrecision.Text & ","
        output &= Form1.Talent_RollingThunder.Text & ","
        output &= Form1.Talent_LavaFlows.Text & ","
        output &= Form1.Talent_Fulmination.Text & ","
        output &= Form1.Talent_LavaSurge.Text & ","
        output &= Form1.Talent_ElementalWeapons.Text & ","

        output &= Other.checkCheck(Form1.GoFTWCheckBox.Checked) & ","
        output &= Other.checkCheck(Form1.GoLCheckBox.Checked) & ","
        output &= Other.checkCheck(Form1.GoLBCheckBox.Checked) & ","
        output &= Other.checkCheck(Form1.GoFSCheckBox.Checked) & ","
        output &= Other.checkCheck(Form1.GoSCheckBox.Checked)

        output &= vbCrLf
        ' Line 4: Compose Character Buffs
        output &= Other.checkCheck(Form1.FlameTongueWeapon.Checked) & ","
        output &= Other.checkCheck(Form1.MailSpecialization.Checked) & ","
        output &= Other.checkCheck(Form1.Heroism.Checked) & ","
        output &= Other.checkCheck(Form1.TotemicWrath.Checked) & ","
        output &= Other.checkCheck(Form1.WrathofAir.Checked) & ","
        output &= Other.checkCheck(Form1.CurseofElements.Checked) & ","
        output &= Other.checkCheck(Form1.WintersChill.Checked)

        output &= vbCrLf
        ' Line 5: Compose Combat Options.
        output &= Other.checkCheck(Form1.Spells_LB.Checked) & ","
        output &= Other.checkCheck(Form1.Spells_CL.Checked) & ","
        output &= Other.checkCheck(Form1.Spells_FS.Checked) & ","
        output &= Other.checkCheck(Form1.Spells_LvB.Checked) & ","
        output &= Other.checkCheck(Form1.Spells_UE.Checked) & ","
        output &= Other.checkCheck(Form1.Spells_ES.Checked) & ","
        output &= Other.checkCheck(Form1.doModel.Checked) & ","
        output &= Form1.FightLength.Text & ","
        output &= Form1.MobLevel.Text & ","
        output &= Form1.AddSpellDmg.Text & ","
        output &= Form1.AddCritPerc.Text & ","
        output &= Form1.AddCritRate.Text & ","
        output &= Form1.AddHitRate.Text & ","
        output &= Form1.AddHasteRate.Text & ","
        output &= Form1.AddMastRate.Text & ","
        output &= Form1.ClearcastUptime.Text & ","
        output &= Form1.LavaSurgeBenefit.Text & ","
        output &= Form1.FulmCharge.Text & ","
        output &= Form1.RollingThunderRamp.Text & ","
        output &= Form1.DefBlueGem.Text & ","
        output &= Form1.DefYellowGem.Text & ","
        output &= Form1.DefRedGem.Text & ","
        output &= Form1.DefMetaGem.Text & ","
        output &= Form1.DefPrisGem.Text & ","
        output &= Form1.Latency.Text & ","
        output &= Form1.instaLatency.Text
        output &= vbCrLf

        ' Line 6+: Compose Gear Sets
        ' First, process the current set, then loop through the Hashtable for the other sets.
        ' Items
        Dim activeSet As String = ""
        If Form1.SetCombo.Text = "" Then activeSet &= "Default" Else activeSet &= Form1.SetCombo.Text
        output &= activeSet & ","
        output &= getItemIDFromName(Form1.HeadCombo.Text) & ","
        output &= getItemIDFromName(Form1.NeckCombo.Text) & ","
        output &= getItemIDFromName(Form1.ShouldersCombo.Text) & ","
        output &= getItemIDFromName(Form1.BackCombo.Text) & ","
        output &= getItemIDFromName(Form1.ChestCombo.Text) & ","
        output &= getItemIDFromName(Form1.WristCombo.Text) & ","
        output &= getItemIDFromName(Form1.MainHandCombo.Text) & ","
        output &= getItemIDFromName(Form1.OffHandCombo.Text) & ","
        output &= getItemIDFromName(Form1.RelicCombo.Text) & ","
        output &= getItemIDFromName(Form1.HandsCombo.Text) & ","
        output &= getItemIDFromName(Form1.WaistCombo.Text) & ","
        output &= getItemIDFromName(Form1.LegsCombo.Text) & ","
        output &= getItemIDFromName(Form1.FeetCombo.Text) & ","
        output &= getItemIDFromName(Form1.Finger1Combo.Text) & ","
        output &= getItemIDFromName(Form1.Finger2Combo.Text) & ","
        output &= getItemIDFromName(Form1.Trinket1Combo.Text) & ","
        output &= getItemIDFromName(Form1.Trinket2Combo.Text) & "."
        ' Gems.

        output &= Variables.CurrentGems.Item("Head") & ","
        output &= Variables.CurrentGems.Item("Neck") & ","
        output &= Variables.CurrentGems.Item("Shoulder") & ","
        output &= Variables.CurrentGems.Item("Back") & ","
        output &= Variables.CurrentGems.Item("Chest") & ","
        output &= Variables.CurrentGems.Item("Wrist") & ","
        output &= Variables.CurrentGems.Item("MainHand") & ","
        output &= Variables.CurrentGems.Item("OffHand") & ","
        output &= Variables.CurrentGems.Item("Relic") & ","
        output &= Variables.CurrentGems.Item("Hands") & ","
        output &= Variables.CurrentGems.Item("Waist") & ","
        output &= Variables.CurrentGems.Item("Legs") & ","
        output &= Variables.CurrentGems.Item("Feet") & ","
        output &= Variables.CurrentGems.Item("Finger1") & ","
        output &= Variables.CurrentGems.Item("Finger2") & ","
        output &= Variables.CurrentGems.Item("Trinket1") & ","
        output &= Variables.CurrentGems.Item("Trinket2") & "."
        ' Enchants.
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Head"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Neck"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Shoulder"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Back"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Chest"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Wrist"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("MainHand"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("OffHand"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Relic"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Hands"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Waist"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Legs"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Feet"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Finger1"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Finger2"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Trinket1"), 0) & ","
        output &= getEnchantInfo(Variables.CurrentEnchants.Item("Trinket2"), 0)
        output &= vbCrLf

        ' Write out the rest of the stored sets.
        Dim setItem As DictionaryEntry
        For Each setItem In Variables.GearSetHash
            If setItem.Key <> activeSet Then
                If setItem.Value <> "" Then output &= setItem.Value & vbCrLf
            End If
        Next

        Dim objWriter As New System.IO.StreamWriter(charfile, True)
        objWriter.WriteLine(output)
        objWriter.Close()
    End Sub

    Public Sub CheckDirs()
        Try
            If Not Directory.Exists("Data") Then Directory.CreateDirectory("Data")
            If Not Directory.Exists("Data\Characters") Then Directory.CreateDirectory("Data\Characters")
        Catch ex As Exception
            MessageBox.Show("Unable to create Data directories: " & ex.Message)
        End Try
    End Sub

    Public Sub NoneOption()
        Form1.HeadCombo.Items.Add("None")
        Form1.NeckCombo.Items.Add("None")
        Form1.ShouldersCombo.Items.Add("None")
        Form1.ChestCombo.Items.Add("None")
        Form1.WaistCombo.Items.Add("None")
        Form1.LegsCombo.Items.Add("None")
        Form1.FeetCombo.Items.Add("None")
        Form1.WristCombo.Items.Add("None")
        Form1.HandsCombo.Items.Add("None")
        Form1.Finger1Combo.Items.Add("None")
        Form1.Finger2Combo.Items.Add("None")
        Form1.Trinket1Combo.Items.Add("None")
        Form1.Trinket2Combo.Items.Add("None")
        Form1.MainHandCombo.Items.Add("None")
        Form1.OffHandCombo.Items.Add("None")
        Form1.BackCombo.Items.Add("None")
        Form1.RelicCombo.Items.Add("None")
    End Sub

    Public Sub loadGearData()
        Try
            If File.Exists("Data\gear.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\gear.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        If sl(0) = "1" Then
                            Variables.HeadArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.HeadCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "2" Then
                            Variables.NeckArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.NeckCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "3" Then
                            Variables.ShoulderArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.ShouldersCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "5" Then
                            Variables.ChestArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.ChestCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "6" Then
                            Variables.WaistArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.WaistCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "7" Then
                            Variables.LegsArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.LegsCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "8" Then
                            Variables.FeetArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.FeetCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "9" Then
                            Variables.WristArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.WristCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "10" Then
                            Variables.HandsArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.HandsCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "11" Then
                            Variables.FingerArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.Finger1Combo.Items.Add(sl(2))
                            Form1.Finger2Combo.Items.Add(sl(2))
                        ElseIf sl(0) = "12" Then
                            Variables.TrinketArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.Trinket1Combo.Items.Add(sl(2))
                            Form1.Trinket2Combo.Items.Add(sl(2))
                        ElseIf sl(0) = "13" Or sl(0) = "17" Or sl(0) = "21" Then ' Mainhand
                            Variables.MainHandArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.MainHandCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "14" Or sl(0) = "23" Then ' Offhand
                            Variables.OffHandArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.OffHandCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "16" Then
                            Variables.BackArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.BackCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "20" Then ' Another chestpiece
                            Variables.ChestArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.ChestCombo.Items.Add(sl(2))
                        ElseIf sl(0) = "28" Then ' Relic
                            Variables.RelicArray.Add(sl(1), line)
                            Variables.AllItemsArray_Name.Add(sl(2), line)
                            Variables.AllItemsArray_Id.Add(sl(1), line)
                            Form1.RelicCombo.Items.Add(sl(2))
                        Else
                            Form1.TextBox1.AppendText("Unknown slot/item: " & line & vbCrLf)
                        End If
                    End If
                Next
                Form1.sortGearDropDown()
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading item: " & ex.Message)
        End Try
    End Sub

    Public Sub loadEnchantData()
        ' ID;Name;Slot;SP;Crit;Hit;Haste;Int;Stam
        Dim i As Integer = 0
        Try
            If File.Exists("Data\enchants.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\enchants.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        Variables.EnchantHash_Id.Add(sl(0), line)
                        If Variables.EnchantHash_Name.Contains(sl(1)) Then Variables.EnchantHash_Name.Add(sl(1) & " (" & sl(0) & ")", line) Else Variables.EnchantHash_Name.Add(sl(1), line)
                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading enchant: " & ex.Message)
        End Try
    End Sub

    Public Sub loadGemData()
        ' ID;Name;Class;SP;Crit;Hit;Haste;Int;Stam;Spi;Hit Dmg;Crit Dmg - Class is which socket
        Try
            If File.Exists("Data\gem.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\gem.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        Variables.GemHash_Id.Add(sl(0), line)
                        If Variables.GemHash_Name.Contains(sl(1)) Then Variables.GemHash_Name.Add(sl(1) & " (" & sl(0) & ")", line) Else Variables.GemHash_Name.Add(sl(1), line)
                        If sl(2) = "0" Or sl(2) = "3" Or sl(2) = "5" Then
                            If Form1.DefRedGem.Items.Contains(sl(1)) Then Form1.DefRedGem.Items.Add(sl(1) & " (" & sl(0) & ")") Else Form1.DefRedGem.Items.Add(sl(1))
                        End If
                        If sl(2) = "1" Or sl(2) = "3" Or sl(2) = "4" Then
                            If Form1.DefBlueGem.Items.Contains(sl(1)) Then Form1.DefBlueGem.Items.Add(sl(1) & " (" & sl(0) & ")") Else Form1.DefBlueGem.Items.Add(sl(1))
                        End If
                        If sl(2) = "2" Or sl(2) = "4" Or sl(2) = "5" Then
                            If Form1.DefYellowGem.Items.Contains(sl(1)) Then Form1.DefYellowGem.Items.Add(sl(1) & " (" & sl(0) & ")") Else Form1.DefYellowGem.Items.Add(sl(1))
                        End If
                        If sl(2) = "6" Then
                            If Form1.DefMetaGem.Items.Contains(sl(1)) Then Form1.DefMetaGem.Items.Add(sl(1) & " (" & sl(0) & ")") Else Form1.DefMetaGem.Items.Add(sl(1))
                        End If
                        ' Add in all gems (except meta) to Prismatic dropdown.
                        If sl(2) <> "6" Then
                            If Form1.DefPrisGem.Items.Contains(sl(1)) Then Form1.DefPrisGem.Items.Add(sl(1) & " (" & sl(0) & ")") Else Form1.DefPrisGem.Items.Add(sl(1))
                        End If

                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading gem: " & ex.Message)
        End Try
    End Sub

    Public Sub loadSocketBonusData()
        ' ID;Item Seen;Info;SP;Crit;Hit;Haste;Int;Stam;MP5;Spirit;Mastery
        Try
            If File.Exists("Data\socketbonus.data") Then
                Dim rawfile() As String = File.ReadAllLines("Data\socketbonus.data")
                For Each line In rawfile
                    Dim sl() As String = Split(line, ";")
                    If UBound(sl) > 0 Then
                        Variables.SocketBonus_Id.Add(sl(0), line)
                        If Variables.SocketBonus_Name.Contains(sl(2)) Then Variables.SocketBonus_Name.Add(sl(2) & " (" & sl(0) & ")", line) Else Variables.SocketBonus_Name.Add(sl(2), line)
                    End If
                Next
            End If
        Catch ex As Exception
            MessageBox.Show("Error loading socket bonus: " & ex.Message)
        End Try
    End Sub

    Public Function getItemIDFromName(ByVal itemname)
        Dim result As String = ""
        If itemname <> "" Then
            Dim rawstring As String = Variables.AllItemsArray_Name.Item(itemname)
            If rawstring <> "" Then
                Dim broken() As String = Split(rawstring, ";")
                If broken(1) <> "" Then result = Trim(broken(1))
            End If
        End If
        Return result
    End Function

    Public Function getItemNameFromId(ByVal itemid)
        Dim result As String = ""
        If itemid <> "" Then
            Dim rawstring As String = Variables.AllItemsArray_Id.Item(itemid)
            If rawstring <> "" Then
                Dim broken() As String = Split(rawstring, ";")
                If broken(2) <> "" Then result = Trim(broken(2))
            End If
        End If
        Return result
    End Function

    Public Function getEnchantInfo(ByVal value, ByVal method)
        Dim result As String = ""

        ' Belt Buckle enchant.
        If value = "1230012" Then
            Return "1230012"
            Exit Function
        End If

        If value = "" Or value = "0" Then
            Return result
            Exit Function
        End If

        If method = 0 Then
            ' Method 0: Getting the ID from the complete string.
            Dim s() As String = Split(value, ";")
            result = Trim(s(0))
        ElseIf method = 1 Then
            ' Method 1: Getting the complete string from the ID
            Dim item As DictionaryEntry
            For Each item In Variables.EnchantHash_Id
                Dim s() As String = Split(item.Value, ";")
                If s(0) = value Then
                    result = Trim(item.Value)
                    Exit For
                End If
            Next
        End If
        Return result
    End Function

    Public Sub getItemfromTextbox(ByVal slot, ByVal itemname)
        If slot <> "" And itemname <> "" Then
            Variables.CurrentGear.Add(slot, Variables.AllItemsArray_Name.Item(itemname))
        End If
    End Sub
End Module

' Notes
' Wowhead Slots
' 1  = Head
' 2  = Neck
' 3  = Shoulders
' 6  = Waist
' 7  = Legs
' 8  = Feet
' 9  = Wrist
' 10 = Hands
' 11 = Finger
' 12 = Trinket
' 13 = One-Handed
' 14 = Shield
' 16 = Back
' 17 = Two-Handed
' 20 = Chest
' 21 = Mainhand ONLY
' 23 = Offhand ONLY
' 28 = Relic
